// El SewedypLCDײ 

#include "LCD.h"
#include <ioavr.h>

#define LCD_DATAREG_COUNT	20		//!< LCDް ڼ޽

//! pA`Gėl
const unsigned char __flash LCD_digitPatterns[10] = {
	(LCD_A_MASK | LCD_B_MASK | LCD_C_MASK | LCD_D_MASK | LCD_E_MASK | LCD_F_MASK),
	(LCD_A_MASK | LCD_B_MASK),
	(LCD_A_MASK | LCD_C_MASK | LCD_D_MASK | LCD_F_MASK | LCD_G_MASK),
	(LCD_A_MASK | LCD_B_MASK | LCD_C_MASK | LCD_F_MASK | LCD_G_MASK),
	(LCD_A_MASK | LCD_B_MASK | LCD_E_MASK | LCD_G_MASK),
	(LCD_B_MASK | LCD_C_MASK | LCD_E_MASK | LCD_F_MASK | LCD_G_MASK),
	(LCD_B_MASK | LCD_C_MASK | LCD_D_MASK | LCD_E_MASK | LCD_F_MASK | LCD_G_MASK),
	(LCD_A_MASK | LCD_B_MASK | LCD_F_MASK),
	(LCD_A_MASK | LCD_B_MASK | LCD_C_MASK | LCD_D_MASK | LCD_E_MASK | LCD_F_MASK | LCD_G_MASK),
	(LCD_A_MASK | LCD_B_MASK | LCD_C_MASK | LCD_E_MASK | LCD_F_MASK | LCD_G_MASK)
};

//! pA`Gėl
const unsigned char __flash LCD_characterPatterns[26] = {
	(LCD_A_MASK | LCD_B_MASK | LCD_D_MASK | LCD_E_MASK | LCD_F_MASK | LCD_G_MASK), // A
	(LCD_B_MASK | LCD_C_MASK | LCD_D_MASK | LCD_E_MASK | LCD_G_MASK), // B
	(LCD_C_MASK | LCD_D_MASK | LCD_E_MASK | LCD_F_MASK), // C
	(LCD_A_MASK | LCD_B_MASK | LCD_C_MASK | LCD_D_MASK), // D
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00  // Z
};

//! LCDĎwWC邽߂̖ԍ0`7蓖ĕ\BSetArrow()ClrArrow()ɂĎgp܂B
const unsigned char __flash LCD_arrowSegmentIdx[6] = {
	LCD_ARROW1_IDX,
	LCD_ARROW2_IDX,
	LCD_ARROW3_IDX,
	LCD_ARROW4_IDX,
	LCD_ARROW5_IDX,
	LCD_ARROW6_IDX
};

void LCD_Init(void)
{
	//  ۯA1/3޲IASCOM݋A24 ݋
	LCDCRB = (0 << LCDCS) | (1 << LCDMUX1) | (1 << LCDMUX0) | (1 << LCDPM2) | (1 << LCDPM1) | (0 << LCDPM0);
	// 4MHzCPUۯLCD61Hzɐݒ
	LCDFRR = (1 << LCDPS2) | (1 << LCDPS1) | (0 << LCDPS0) | (0 << LCDCD2) | (1 << LCDCD1) | (1 << LCDCD0);
	// ZWݒ
    LCD_SetContrast( 0x0f );
	// LCD
	LCDCRA = (1 << LCDEN);
}

void LCD_SetContrast(unsigned char level)
{
	LCDCCR = LCDCCR & 0x0f | (level & 0x0f);
}

void LCD_ClearAllSegments(void)
{
	volatile unsigned char * lcdRegPtr = &LCDDR0;
	for (unsigned char i = 0; i < LCD_DATAREG_COUNT; ++i)
	{
		*lcdRegPtr = 0x00;
		++lcdRegPtr;
	}
}

void LCD_ClearAllButArrowsAndBatt(void)
{
	// ƓdȑԂi[
	unsigned char battState = LCD_GetSegment( LCD_BATTERY_IDX );
	unsigned char arrow1State = LCD_GetSegment( LCD_ARROW1_IDX );
	unsigned char arrow2State = LCD_GetSegment( LCD_ARROW2_IDX );
	unsigned char arrow3State = LCD_GetSegment( LCD_ARROW3_IDX );
	unsigned char arrow4State = LCD_GetSegment( LCD_ARROW4_IDX );
	unsigned char arrow5State = LCD_GetSegment( LCD_ARROW5_IDX );
	unsigned char arrow6State = LCD_GetSegment( LCD_ARROW6_IDX );

	// SLCDď
	LCD_ClearAllSegments();

	// ƓdȑԂ𕜌
	if (battState   != 0x00) { LCD_SetSegment( LCD_BATTERY_IDX ); }
	if (arrow1State != 0x00) { LCD_SetSegment( LCD_ARROW1_IDX );  }
	if (arrow2State != 0x00) { LCD_SetSegment( LCD_ARROW2_IDX );  }
	if (arrow3State != 0x00) { LCD_SetSegment( LCD_ARROW3_IDX );  }
	if (arrow4State != 0x00) { LCD_SetSegment( LCD_ARROW4_IDX );  }
	if (arrow5State != 0x00) { LCD_SetSegment( LCD_ARROW5_IDX );  }
	if (arrow6State != 0x00) { LCD_SetSegment( LCD_ARROW6_IDX );  }
}

void LCD_SetArrow(unsigned char arrowNo)
{
	if ((arrowNo >= 1) && (arrowNo <= 6))
	{
		LCD_SetSegment( LCD_arrowSegmentIdx[arrowNo-1] );
	}
}

void LCD_ClrArrow(unsigned char arrowNo)
{
	if ((arrowNo >= 1) && (arrowNo <= 6))
	{
		LCD_ClrSegment( LCD_arrowSegmentIdx[arrowNo-1] );
	}
}

void LCD_SetSegment(unsigned char index)
{
	// wW(Index):2ޯĂCOMA6ޯĂSEG
	unsigned char com = (index >> 6) & 0x03;
	unsigned char seg = index & 0x3f;

	// (SEG):(6)3ޯĂ޲ĕψ(̾)A3ޯĂޯĕψ(̾)
	unsigned char byteOffset = (seg >> 3) & 0x07;
	unsigned char bitOffset = seg & 0x07;

	// ʓd(COM):5޲ĉI
	unsigned char blockOffset = com * 5;

	// LCDް ڼ޽1ޯĂݒ(1)
	volatile unsigned char * lcdRegPtr = &LCDDR0;
	lcdRegPtr[blockOffset + byteOffset] |= (1 << bitOffset);
}

void LCD_ClrSegment(unsigned char index)
{
	// wW(Index):2ޯĂCOMA6ޯĂSEG
	unsigned char com = (index >> 6) & 0x03;
	unsigned char seg = index & 0x3f;

	// (SEG):(6)3ޯĂ޲ĕψ(̾)A3ޯĂޯĕψ(̾)
	unsigned char byteOffset = (seg >> 3) & 0x07;
	unsigned char bitOffset = seg & 0x07;

	// ʓd(COM):5޲ĉI
	unsigned char blockOffset = com * 5;

	// LCDް ڼ޽1ޯĂ(0)
	volatile unsigned char * lcdRegPtr = &LCDDR0;
	lcdRegPtr[blockOffset + byteOffset] &= ~(1 << bitOffset);
}

unsigned char LCD_GetSegment(unsigned char index)
{
	// wW(Index):2ޯĂCOMA6ޯĂSEG
	unsigned char com = (index >> 6) & 0x03;
	unsigned char seg = index & 0x3f;

	// (SEG):(6)3ޯĂ޲ĕψ(̾)A3ޯĂޯĕψ(̾)
	unsigned char byteOffset = (seg >> 3) & 0x07;
	unsigned char bitOffset = seg & 0x07;

	// ʓd(COM):5޲ĉI
	unsigned char blockOffset = com * 5;

	// LCDް ڼ޽1ޯĂ擾
	volatile unsigned char * lcdRegPtr = &LCDDR0;
	unsigned char result = lcdRegPtr[blockOffset + byteOffset] & (1 << bitOffset);

	// Ăݒ(1)̏ꍇ0ȊOԂB
	return (result != 0x00);
}

void LCD_SetPattern(unsigned char pattern, unsigned char pos)
{
	// pos=1`8
	unsigned char startSegment = 2 + ((pos - 1) * 2);

	if ((pattern & LCD_A_MASK) != 0)
	{
		LCD_SetSegment( LCD_GENIDX( 1, (startSegment + 1) ) );
	}
	else
	{
		LCD_ClrSegment( LCD_GENIDX( 1, (startSegment + 1) ) );
	}

	if ((pattern & LCD_B_MASK) != 0)
	{
		LCD_SetSegment( LCD_GENIDX( 2, (startSegment + 1) ) );
	}
	else
	{
		LCD_ClrSegment( LCD_GENIDX( 2, (startSegment + 1) ) );
	}

	if ((pattern & LCD_C_MASK) != 0)
	{
		LCD_SetSegment( LCD_GENIDX( 3, (startSegment + 0) ) );
	}
	else
	{
		LCD_ClrSegment( LCD_GENIDX( 3, (startSegment + 0) ) );
	}

	if ((pattern & LCD_D_MASK) != 0)
	{
		LCD_SetSegment( LCD_GENIDX( 2, (startSegment + 0) ) );
	}
	else
	{
		LCD_ClrSegment( LCD_GENIDX( 2, (startSegment + 0) ) );
	}

	if ((pattern & LCD_E_MASK) != 0)
	{
		LCD_SetSegment( LCD_GENIDX( 0, (startSegment + 0) ) );
	}
	else
	{
		LCD_ClrSegment( LCD_GENIDX( 0, (startSegment + 0) ) );
	}

	if ((pattern & LCD_F_MASK) != 0)
	{
		LCD_SetSegment( LCD_GENIDX( 0, (startSegment + 1) ) );
	}
	else
	{
		LCD_ClrSegment( LCD_GENIDX( 0, (startSegment + 1) ) );
	}

	if ((pattern & LCD_G_MASK) != 0)
	{
		LCD_SetSegment( LCD_GENIDX( 1, (startSegment + 0) ) );
	}
	else
	{
		LCD_ClrSegment( LCD_GENIDX( 1, (startSegment + 0) ) );
	}
}

void LCD_SetDigit(unsigned char digit, unsigned char pos)
{
	if (digit <= 9)
	{
		LCD_SetPattern(LCD_digitPatterns[digit], pos);
	}
	else
	{
		LCD_SetPattern(0x00, pos);
	}
}

void LCD_SetCharacter(char ch, unsigned char pos)
{
	if ((ch >= 'A') && (ch <= 'Z'))
	{
		LCD_SetPattern(LCD_characterPatterns[ch - 'A'], pos);
	}
	else if ((ch >= 'a') && (ch <= 'z'))
	{
		LCD_SetPattern(LCD_characterPatterns[ch - 'a'], pos);
	}
	else
	{
		LCD_SetPattern(0x00, pos);
	}
}
